package {
	import mx.controls.Alert;
	import mx.core.Application;
	import mx.rpc.events.FaultEvent;
	import mx.rpc.events.ResultEvent;
	import mx.rpc.remoting.RemoteObject;

	public class HelloLogic extends Application {

		private var view:HelloView = this as HelloView;
		public function HelloLogic() {
			super();
		}

		/* Hello Service */
		protected function hello():void {
			var helloService:RemoteObject = new RemoteObject("helloService");
			helloService.addEventListener(ResultEvent.RESULT, helloHandler);
			helloService.addEventListener(FaultEvent.FAULT, serviceFaultHandler);

			helloService.hello(view.formName.text);
			busyAdd();
		}
		private function helloHandler(event:ResultEvent):void {
			var message:String = event.result as String;
			Alert.show("Message: " + message);
			busyRemove();
		}
		private function serviceFaultHandler(event:FaultEvent):void {
			busyRemove();
			if (event.fault.rootCause != null && event.fault.rootCause.hasOwnProperty("message")) {
				Alert.show(event.fault.rootCause.message);
			} else {
				Alert.show(event.message.toString());
			}
		}

		/* Busy Icon Controll */
		private var busys:int = 0;
		private function busyAdd():void {
			if (this.busys == 0) {
				cursorManager.setBusyCursor();
			}
			this.busys++;
		}
		private function busyRemove():void {
			this.busys--;
			if (this.busys < 0) this.busys = 0;
			if (this.busys == 0) {
				cursorManager.removeBusyCursor();
			}
		}
	}
}
